net.fortuna.ical4j.model.property

## Class DtEnd

- java.lang.Object
- - net.fortuna.ical4j.model.Content
  - - net.fortuna.ical4j.model.Property
    - - net.fortuna.ical4j.model.property.DateProperty
      - - net.fortuna.ical4j.model.property.DtEnd

All Implemented Interfaces:
  Serializable

    public class DtEnd
    extends DateProperty

$Id$ Created: [Apr 6, 2004] Defines a DTEND iCalendar component property.

         4.8.2.2 Date/Time End

            Property Name: DTEND

            Purpose: This property specifies the date and time that a calendar
            component ends.

            Value Type: The default value type is DATE-TIME. The value type can
            be set to a DATE value type.

            Property Parameters: Non-standard, value data type, time zone
            identifier property parameters can be specified on this property.

            Conformance: This property can be specified in "VEVENT" or
            "VFREEBUSY" calendar components.

            Description: Within the "VEVENT" calendar component, this property
            defines the date and time by which the event ends. The value MUST be
            later in time than the value of the "DTSTART" property.

            Within the "VFREEBUSY" calendar component, this property defines the
            end date and time for the free or busy time information. The time
            MUST be specified in the UTC time format. The value MUST be later in
            time than the value of the "DTSTART" property.

            Format Definition: The property is defined by the following notation:

              dtend      = "DTEND" dtendparam":" dtendval CRLF

              dtendparam = *(

                         ; the following are optional,
                         ; but MUST NOT occur more than once

                         (";" "VALUE" "=" ("DATE-TIME" / "DATE")) /
                         (";" tzidparam) /

                         ; the following is optional,
                         ; and MAY occur more than once

                         (";" xparam)

                         )

              dtendval   = date-time / date
              ;Value MUST match value type

Examples:

          // construct an end date from a start date and a duration..
          DtStart start = ...
          Dur oneWeek = new Dur("1W");
          DtEnd end = new DtEnd(oneWeek.getTime(start.getDate());

Author:
  Ben Fortuna
See Also:
  Serialized Form

### Field Summary

### Fields inherited from class net.fortuna.ical4j.model.Property

`ACTION, ATTACH, ATTENDEE, BUSYTYPE, CALSCALE, CATEGORIES, CLASS, COMMENT, COMPLETED, CONTACT, COUNTRY, CREATED, DESCRIPTION, DTEND, DTSTAMP, DTSTART, DUE, DURATION, EXDATE, EXPERIMENTAL_PREFIX, EXRULE, EXTENDED_ADDRESS, FREEBUSY, GEO, LAST_MODIFIED, LOCALITY, LOCATION, LOCATION_TYPE, METHOD, NAME, ORGANIZER, PERCENT_COMPLETE, POSTALCODE, PRIORITY, PRODID, RDATE, RECURRENCE_ID, REGION, RELATED_TO, REPEAT, REQUEST_STATUS, RESOURCES, RRULE, SEQUENCE, STATUS, STREET_ADDRESS, SUMMARY, TEL, TRANSP, TRIGGER, TZID, TZNAME, TZOFFSETFROM, TZOFFSETTO, TZURL, UID, URL, VERSION`

### Constructor Summary

Constructors
Constructor and Description
`DtEnd()` Default constructor.
`DtEnd(Date aDate)` Constructor.
`DtEnd(Date time, boolean utc)` Constructs a new DtEnd with the specified time.
`DtEnd(ParameterList aList, Date aDate)` Constructor.
`DtEnd(ParameterList aList, String aValue)`
`DtEnd(String value)` Creates a new instance initialised with the parsed value.
`DtEnd(String value, TimeZone timezone)` Creates a new DTEND property initialised with the specified timezone and value.
`DtEnd(TimeZone timezone)` Creates a new DTEND property initialised with the specified timezone.

### Method Summary

Methods
`void` `validate()` Perform validation on a property.

### Methods inherited from class net.fortuna.ical4j.model.property.DateProperty

`copy, getDate, getTimeZone, getValue, hashCode, isUtc, setDate, setTimeZone, setUtc, setValue`

### Methods inherited from class net.fortuna.ical4j.model.Property

`equals, getName, getParameter, getParameters, getParameters, isCalendarProperty, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### DtEnd

    public DtEnd()

Default constructor. The time value is initialised to the time of instantiation.

#### DtEnd

    public DtEnd(TimeZone timezone)

Creates a new DTEND property initialised with the specified timezone.

Parameters:
  `timezone` - initial timezone

#### DtEnd

    public DtEnd(String value)
          throws ParseException

Creates a new instance initialised with the parsed value.

Parameters:
  `value` - the DTEND value string to parse
Throws:
  `ParseException` - where the specified string is not a valid DTEND value representation

#### DtEnd

    public DtEnd(String value,
         TimeZone timezone)
          throws ParseException

Creates a new DTEND property initialised with the specified timezone and value.

Parameters:
  `value` - a string representation of a DTEND value
  `timezone` - initial timezone
Throws:
  `ParseException` - where the specified value is not a valid string representation

#### DtEnd

    public DtEnd(ParameterList aList,
         String aValue)
          throws ParseException

Parameters:
  `aList` - a list of parameters for this component
  `aValue` - a value string for this component
Throws:
  `ParseException` - when the specified string is not a valid date/date-time representation

#### DtEnd

    public DtEnd(Date aDate)

Constructor. Date or Date-Time format is determined based on the presence of a VALUE parameter.

Parameters:
  `aDate` - a date

#### DtEnd

    public DtEnd(Date time,
         boolean utc)

Constructs a new DtEnd with the specified time.

Parameters:
  `time` - the time of the DtEnd
  `utc` - specifies whether time is UTC

#### DtEnd

    public DtEnd(ParameterList aList,
         Date aDate)

Constructor. Date or Date-Time format is determined based on the presence of a VALUE parameter.

Parameters:
  `aList` - a list of parameters for this component
  `aDate` - a date

### Method Detail

#### validate

    public final void validate()
                        throws ValidationException

Perform validation on a property.

Overrides:
  `validate` in class `DateProperty`
Throws:
  `ValidationException` - where the property is not in a valid state